/***************************************************************************
 *
 * InitListe( Tete )                   initialise une tete de liste
 * InsereTete( Tete , Elem )           insere un element en tete de liste
 * InsereQueue( Tete , Elem )          insere un element en queue de liste
 * InsereElem( Tete , Prec , Elem )    insere un element apres un autre
 * VideListe( Tete )                   enleve tous les elements d'une liste
 * EnleveTete( Tete )                  enleve l'element en tete de liste
 * EnleveQueue( Tete )                 enleve l'element en queue de liste
 * EnleveElem( Tete , Elem )           enleve un element d'une liste
 *
 ***************************************************************************/

#include "aroff.h"

/*-------------------------------------------------------------------------*/

void InitListe( Tete )
struct TeteListe *Tete ;

{
  Tete->tl_Premier = NULL ;
  Tete->tl_Dernier = NULL ;
  Tete->tl_NbrElem = 0L ;
}

/*-------------------------------------------------------------------------*/

void InsereTete( Tete , Elem )
register struct TeteListe *Tete ;
register struct Noeud *Elem ;
{
  Elem->el_Suivant = Tete->tl_Premier ;
  Elem->el_Precedant = NULL ;
  if ( Tete->tl_Premier ) Tete->tl_Premier->el_Precedant = Elem ;

  Tete->tl_Premier = Elem ;
  if (! Tete->tl_Dernier) Tete->tl_Dernier = Elem ;
  Tete->tl_NbrElem++ ;
}

/*-------------------------------------------------------------------------*/

void InsereQueue( Tete , Elem )
register struct TeteListe *Tete ;
register struct Noeud *Elem ;
{
  Elem->el_Suivant = NULL ;
  Elem->el_Precedant = Tete->tl_Dernier ;
  if ( Tete->tl_Dernier ) Tete->tl_Dernier->el_Suivant = Elem ;

  Tete->tl_Dernier = Elem ;
  if (! Tete->tl_Premier) Tete->tl_Premier = Elem ;
  Tete->tl_NbrElem++ ;
}

/*-------------------------------------------------------------------------*/

/***** NOT USED TILL NOW !

void InsereElem( Tete , Prec , Elem )
struct TeteListe *Tete ;
register struct Noeud *Prec , *Elem ;
{
  Elem->el_Suivant = Prec->el_Suivant ;
  Elem->el_Precedant = Prec ;

  Prec->el_Suivant = Elem ;
  if ( Elem->el_Suivant )
    Elem->el_Suivant->el_Precedant = Elem ;
  else
    Tete->tl_Dernier = Elem ;

  Tete->tl_NbrElem++ ;
}

*****/

/*-------------------------------------------------------------------------*/

void VideListe( Tete )
struct TeteListe *Tete ;
{
  register struct Noeud *p , *q ;

  for ( p = Tete->tl_Premier ; p ; p = q )
  {
    q = p->el_Suivant ;
    free( p ) ;
  }

  InitListe( Tete ) ;
}

/*-------------------------------------------------------------------------*/

/***** NOT USED TILL NOW !

void EnleveTete( Tete )
register struct TeteListe *Tete ;
{
  register struct Noeud *p ;

  p = Tete->tl_Premier ;
  if (! p) return ;

  Tete->tl_Premier = p->el_Suivant ;
  if ( p->el_Suivant )
    p->el_Suivant->el_Precedant = NULL ;
  else
    Tete->tl_Dernier = NULL ;

  free( p ) ;
  Tete->tl_NbrElem-- ;
}

*****/

/*-------------------------------------------------------------------------*/

void EnleveQueue( Tete )
register struct TeteListe *Tete ;
{
  register struct Noeud *p ;

  p = Tete->tl_Dernier ;
  if (! p) return ;

  Tete->tl_Dernier = p->el_Precedant ;
  if ( p->el_Precedant )
    p->el_Precedant->el_Suivant = NULL ;
  else
    Tete->tl_Premier = NULL ;

  free( p ) ;
  Tete->tl_NbrElem-- ;
}

/*-------------------------------------------------------------------------*/

void EnleveElem( Tete , Elem )
register struct TeteListe *Tete ;
register struct Noeud *Elem ;
{
  if ( Elem->el_Precedant )
    Elem->el_Precedant->el_Suivant = Elem->el_Suivant ;
  else
    Tete->tl_Premier = Elem->el_Suivant ;

  if ( Elem->el_Suivant )
    Elem->el_Suivant->el_Precedant = Elem->el_Precedant ;
  else
    Tete->tl_Dernier = Elem->el_Precedant ;

  free( Elem ) ;
  Tete->tl_NbrElem-- ;
}

